gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Interfaces.FileChooser

Contents

- Exported types
- Methods
  - addChoice
  - addFilter
  - addShortcutFolder
  - addShortcutFolderUri
  - getAction
  - getChoice
  - getCreateFolders
  - getCurrentFolder
  - getCurrentFolderFile
  - getCurrentFolderUri
  - getCurrentName
  - getDoOverwriteConfirmation
  - getExtraWidget
  - getFile
  - getFilename
  - getFilenames
  - getFiles
  - getFilter
  - getLocalOnly
  - getPreviewFile
  - getPreviewFilename
  - getPreviewUri
  - getPreviewWidget
  - getPreviewWidgetActive
  - getSelectMultiple
  - getShowHidden
  - getUri
  - getUris
  - getUsePreviewLabel
  - listFilters
  - listShortcutFolderUris
  - listShortcutFolders
  - removeChoice
  - removeFilter
  - removeShortcutFolder
  - removeShortcutFolderUri
  - selectAll
  - selectFile
  - selectFilename
  - selectUri
  - setAction
  - setChoice
  - setCreateFolders
  - setCurrentFolder
  - setCurrentFolderFile
  - setCurrentFolderUri
  - setCurrentName
  - setDoOverwriteConfirmation
  - setExtraWidget
  - setFile
  - setFilename
  - setFilter
  - setLocalOnly
  - setPreviewWidget
  - setPreviewWidgetActive
  - setSelectMultiple
  - setShowHidden
  - setUri
  - setUsePreviewLabel
  - unselectAll
  - unselectFile
  - unselectFilename
  - unselectUri
- Properties
  - action
  - createFolders
  - doOverwriteConfirmation
  - extraWidget
  - filter
  - localOnly
  - previewWidget
  - previewWidgetActive
  - selectMultiple
  - showHidden
  - usePreviewLabel
- Signals
  - confirmOverwrite
  - currentFolderChanged
  - fileActivated
  - selectionChanged
  - updatePreview

Description

`FileChooser` is an interface that can be implemented by file selection widgets. In GTK+, the main objects that implement this interface are `FileChooserWidget`, `FileChooserDialog`, and `FileChooserButton`. You do not need to write an object that implements the `FileChooser` interface unless you are trying to adapt an existing file selector to expose a standard programming interface.

`FileChooser` allows for shortcuts to various places in the filesystem. In the default implementation these are displayed in the left pane. It may be a bit confusing at first that these shortcuts come from various sources and in various flavours, so lets explain the terminology here:

- Bookmarks: are created by the user, by dragging folders from the right pane to the left pane, or by using the “Add”. Bookmarks can be renamed and deleted by the user.
- Shortcuts: can be provided by the application. For example, a Paint program may want to add a shortcut for a Clipart folder. Shortcuts cannot be modified by the user.
- Volumes: are provided by the underlying filesystem abstraction. They are the “roots” of the filesystem.

# File Names and Encodings

When the user is finished selecting files in a `FileChooser`, your program can get the selected names either as filenames or as URIs. For URIs, the normal escaping rules are applied if the URI contains non-ASCII characters. However, filenames are always returned in the character set specified by the `G_FILENAME_ENCODING` environment variable. Please see the GLib documentation for more details about this variable.

This means that while you can pass the result of `fileChooserGetFilename` to `open` or `fopen`, you may not be able to directly set it as the text of a `Label` widget unless you convert it first to UTF-8, which all GTK+ widgets expect. You should use `filenameToUtf8` to convert filenames into strings that can be passed to GTK+ widgets.

# Adding a Preview Widget

You can add a custom preview widget to a file chooser and then get notification about when the preview needs to be updated. To install a preview widget, use `fileChooserSetPreviewWidget`. Then, connect to the FileChooser::updatePreview signal to get notified when you need to update the contents of the preview.

Your callback should use `fileChooserGetPreviewFilename` to see what needs previewing. Once you have generated the preview for the corresponding file, you must call `fileChooserSetPreviewWidgetActive` with a boolean flag that indicates whether your callback could successfully generate a preview.

## Example: Using a Preview Widget ## {`gtkfilechooser`-preview}

### C code

    {
      GtkImage *preview;

      ...

      preview = gtk_image_new ();

      gtk_file_chooser_set_preview_widget (my_file_chooser, preview);
      g_signal_connect (my_file_chooser, "update-preview",
    		    G_CALLBACK (update_preview_cb), preview);
    }

    static void
    update_preview_cb (GtkFileChooser *file_chooser, gpointer data)
    {
      GtkWidget *preview;
      char *filename;
      GdkPixbuf *pixbuf;
      gboolean have_preview;

      preview = GTK_WIDGET (data);
      filename = gtk_file_chooser_get_preview_filename (file_chooser);

      pixbuf = gdk_pixbuf_new_from_file_at_size (filename, 128, 128, NULL);
      have_preview = (pixbuf != NULL);
      g_free (filename);

      gtk_image_set_from_pixbuf (GTK_IMAGE (preview), pixbuf);
      if (pixbuf)
        g_object_unref (pixbuf);

      gtk_file_chooser_set_preview_widget_active (file_chooser, have_preview);
    }

# Adding Extra Widgets

You can add extra widgets to a file chooser to provide options that are not present in the default design. For example, you can add a toggle button to give the user the option to open a file in read-only mode. You can use `fileChooserSetExtraWidget` to insert additional widgets in a file chooser.

An example for adding extra widgets:

### C code

      GtkWidget *toggle;

      ...

      toggle = gtk_check_button_new_with_label ("Open file read-only");
      gtk_widget_show (toggle);
      gtk_file_chooser_set_extra_widget (my_file_chooser, toggle);
    }

If you want to set more than one extra widget in the file chooser, you can a container such as a `Box` or a `Grid` and include your widgets in it. Then, set the container as the whole extra widget.

Synopsis

- newtype FileChooser = FileChooser (ManagedPtr FileChooser)
- class (GObject o, IsDescendantOf FileChooser o) => IsFileChooser o
- toFileChooser :: (MonadIO m, IsFileChooser o) => o -> m FileChooser
- fileChooserAddChoice :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> Text -> Maybe [Text] -> Maybe [Text] -> m ()
- fileChooserAddFilter :: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) => a -> b -> m ()
- fileChooserAddShortcutFolder :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m ()
- fileChooserAddShortcutFolderUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m ()
- fileChooserGetAction :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m FileChooserAction
- fileChooserGetChoice :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m Text
- fileChooserGetCreateFolders :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetCurrentFolder :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe [Char])
- fileChooserGetCurrentFolderFile :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe File)
- fileChooserGetCurrentFolderUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe Text)
- fileChooserGetCurrentName :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Text
- fileChooserGetDoOverwriteConfirmation :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetExtraWidget :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe Widget)
- fileChooserGetFile :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m File
- fileChooserGetFilename :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe [Char])
- fileChooserGetFilenames :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [[Char]]
- fileChooserGetFiles :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [File]
- fileChooserGetFilter :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe FileFilter)
- fileChooserGetLocalOnly :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetPreviewFile :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe File)
- fileChooserGetPreviewFilename :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe [Char])
- fileChooserGetPreviewUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe Text)
- fileChooserGetPreviewWidget :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe Widget)
- fileChooserGetPreviewWidgetActive :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetSelectMultiple :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetShowHidden :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserGetUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m (Maybe Text)
- fileChooserGetUris :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [Text]
- fileChooserGetUsePreviewLabel :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m Bool
- fileChooserListFilters :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [FileFilter]
- fileChooserListShortcutFolderUris :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [Text]
- fileChooserListShortcutFolders :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m [[Char]]
- fileChooserRemoveChoice :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m ()
- fileChooserRemoveFilter :: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) => a -> b -> m ()
- fileChooserRemoveShortcutFolder :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m ()
- fileChooserRemoveShortcutFolderUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m ()
- fileChooserSelectAll :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m ()
- fileChooserSelectFile :: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) => a -> b -> m ()
- fileChooserSelectFilename :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m Bool
- fileChooserSelectUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m Bool
- fileChooserSetAction :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> FileChooserAction -> m ()
- fileChooserSetChoice :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> Text -> m ()
- fileChooserSetCreateFolders :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetCurrentFolder :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m Bool
- fileChooserSetCurrentFolderFile :: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) => a -> b -> m ()
- fileChooserSetCurrentFolderUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m Bool
- fileChooserSetCurrentName :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m ()
- fileChooserSetDoOverwriteConfirmation :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetExtraWidget :: (HasCallStack, MonadIO m, IsFileChooser a, IsWidget b) => a -> b -> m ()
- fileChooserSetFile :: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) => a -> b -> m ()
- fileChooserSetFilename :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m Bool
- fileChooserSetFilter :: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) => a -> b -> m ()
- fileChooserSetLocalOnly :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetPreviewWidget :: (HasCallStack, MonadIO m, IsFileChooser a, IsWidget b) => a -> b -> m ()
- fileChooserSetPreviewWidgetActive :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetSelectMultiple :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetShowHidden :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserSetUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m Bool
- fileChooserSetUsePreviewLabel :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Bool -> m ()
- fileChooserUnselectAll :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> m ()
- fileChooserUnselectFile :: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) => a -> b -> m ()
- fileChooserUnselectFilename :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> [Char] -> m ()
- fileChooserUnselectUri :: (HasCallStack, MonadIO m, IsFileChooser a) => a -> Text -> m ()
- constructFileChooserAction :: (IsFileChooser o, MonadIO m) => FileChooserAction -> m (GValueConstruct o)
- getFileChooserAction :: (MonadIO m, IsFileChooser o) => o -> m FileChooserAction
- setFileChooserAction :: (MonadIO m, IsFileChooser o) => o -> FileChooserAction -> m ()
- constructFileChooserCreateFolders :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserCreateFolders :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserCreateFolders :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserDoOverwriteConfirmation :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserDoOverwriteConfirmation :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserDoOverwriteConfirmation :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserExtraWidget :: (IsFileChooser o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o)
- getFileChooserExtraWidget :: (MonadIO m, IsFileChooser o) => o -> m (Maybe Widget)
- setFileChooserExtraWidget :: (MonadIO m, IsFileChooser o, IsWidget a) => o -> a -> m ()
- constructFileChooserFilter :: (IsFileChooser o, MonadIO m, IsFileFilter a) => a -> m (GValueConstruct o)
- getFileChooserFilter :: (MonadIO m, IsFileChooser o) => o -> m (Maybe FileFilter)
- setFileChooserFilter :: (MonadIO m, IsFileChooser o, IsFileFilter a) => o -> a -> m ()
- constructFileChooserLocalOnly :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserLocalOnly :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserLocalOnly :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserPreviewWidget :: (IsFileChooser o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o)
- getFileChooserPreviewWidget :: (MonadIO m, IsFileChooser o) => o -> m (Maybe Widget)
- setFileChooserPreviewWidget :: (MonadIO m, IsFileChooser o, IsWidget a) => o -> a -> m ()
- constructFileChooserPreviewWidgetActive :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserPreviewWidgetActive :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserPreviewWidgetActive :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserSelectMultiple :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserSelectMultiple :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserSelectMultiple :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserShowHidden :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserShowHidden :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserShowHidden :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- constructFileChooserUsePreviewLabel :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o)
- getFileChooserUsePreviewLabel :: (MonadIO m, IsFileChooser o) => o -> m Bool
- setFileChooserUsePreviewLabel :: (MonadIO m, IsFileChooser o) => o -> Bool -> m ()
- type FileChooserConfirmOverwriteCallback = IO FileChooserConfirmation
- afterFileChooserConfirmOverwrite :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserConfirmOverwriteCallback) -> m SignalHandlerId
- onFileChooserConfirmOverwrite :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserConfirmOverwriteCallback) -> m SignalHandlerId
- type FileChooserCurrentFolderChangedCallback = IO ()
- afterFileChooserCurrentFolderChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserCurrentFolderChangedCallback) -> m SignalHandlerId
- onFileChooserCurrentFolderChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserCurrentFolderChangedCallback) -> m SignalHandlerId
- type FileChooserFileActivatedCallback = IO ()
- afterFileChooserFileActivated :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserFileActivatedCallback) -> m SignalHandlerId
- onFileChooserFileActivated :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserFileActivatedCallback) -> m SignalHandlerId
- type FileChooserSelectionChangedCallback = IO ()
- afterFileChooserSelectionChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserSelectionChangedCallback) -> m SignalHandlerId
- onFileChooserSelectionChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserSelectionChangedCallback) -> m SignalHandlerId
- type FileChooserUpdatePreviewCallback = IO ()
- afterFileChooserUpdatePreview :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserUpdatePreviewCallback) -> m SignalHandlerId
- onFileChooserUpdatePreview :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserUpdatePreviewCallback) -> m SignalHandlerId

# Exported types

newtype FileChooser Source #

Memory-managed wrapper type.

Constructors

FileChooser (ManagedPtr FileChooser) |

#### Instances

Instances details

Eq FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser Methods (==) :: FileChooser -> FileChooser -> Bool Source # (/=) :: FileChooser -> FileChooser -> Bool Source #
GObject FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser
ManagedPtrNewtype FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser Methods toManagedPtr :: FileChooser -> ManagedPtr FileChooser Source #
TypedObject FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser Methods glibType :: IO GType Source #
HasParentTypes FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser
IsGValue (Maybe FileChooser) Source # | Convert `FileChooser` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Interfaces.FileChooser Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe FileChooser -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe FileChooser) Source #
type ParentTypes FileChooser Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser type ParentTypes FileChooser = '[Object]

class (GObject o, IsDescendantOf FileChooser o) => IsFileChooser o Source #

Type class for types which can be safely cast to `FileChooser`, for instance with `toFileChooser`.

#### Instances

Instances details

(GObject o, IsDescendantOf FileChooser o) => IsFileChooser o Source # |
Instance details Defined in GI.Gtk.Interfaces.FileChooser

toFileChooser :: (MonadIO m, IsFileChooser o) => o -> m FileChooser Source #

Cast to `FileChooser`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addChoice, addFilter, addShortcutFolder, addShortcutFolderUri, bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, listFilters, listShortcutFolderUris, listShortcutFolders, notify, notifyByPspec, ref, refSink, removeChoice, removeFilter, removeShortcutFolder, removeShortcutFolderUri, runDispose, selectAll, selectFile, selectFilename, selectUri, stealData, stealQdata, thawNotify, unref, unselectAll, unselectFile, unselectFilename, unselectUri, watchClosure.

#### Getters

getAction, getChoice, getCreateFolders, getCurrentFolder, getCurrentFolderFile, getCurrentFolderUri, getCurrentName, getData, getDoOverwriteConfirmation, getExtraWidget, getFile, getFilename, getFilenames, getFiles, getFilter, getLocalOnly, getPreviewFile, getPreviewFilename, getPreviewUri, getPreviewWidget, getPreviewWidgetActive, getProperty, getQdata, getSelectMultiple, getShowHidden, getUri, getUris, getUsePreviewLabel.

#### Setters

setAction, setChoice, setCreateFolders, setCurrentFolder, setCurrentFolderFile, setCurrentFolderUri, setCurrentName, setData, setDataFull, setDoOverwriteConfirmation, setExtraWidget, setFile, setFilename, setFilter, setLocalOnly, setPreviewWidget, setPreviewWidgetActive, setProperty, setSelectMultiple, setShowHidden, setUri, setUsePreviewLabel.

## addChoice

fileChooserAddChoice Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `id`: id for the added choice
-> Text | `label`: user-visible label for the added choice
-> Maybe [Text] | `options`: ids for the options of the choice, or `Nothing` for a boolean choice
-> Maybe [Text] | `optionLabels`: user-visible labels for the options, must be the same length as `options`
-> m () |

Adds a 'choice' to the file chooser. This is typically implemented as a combobox or, for boolean choices, as a checkbutton. You can select a value using `fileChooserSetChoice` before the dialog is shown, and you can obtain the user-selected value in the response signal handler using `fileChooserGetChoice`.

Compare `fileChooserSetExtraWidget`.

Since: 3.22

## addFilter

fileChooserAddFilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) |
=> a | `chooser`: a `FileChooser`
-> b | `filter`: a `FileFilter`
-> m () |

Adds `filter` to the list of filters that the user can select between. When a filter is selected, only files that are passed by that filter are displayed.

Note that the `chooser` takes ownership of the filter, so you have to ref and sink it if you want to keep a reference.

Since: 2.4

## addShortcutFolder

fileChooserAddShortcutFolder Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `folder`: filename of the folder to add
-> m () | (Can throw `GError`)

Adds a folder to be displayed with the shortcut folders in a file chooser. Note that shortcut folders do not get saved, as they are provided by the application. For example, you can use this to add a “/usr/share/mydrawprogram/Clipart” folder to the volume list.

Since: 2.4

## addShortcutFolderUri

fileChooserAddShortcutFolderUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: URI of the folder to add
-> m () | (Can throw `GError`)

Adds a folder URI to be displayed with the shortcut folders in a file chooser. Note that shortcut folders do not get saved, as they are provided by the application. For example, you can use this to add a “file:///usr/share/mydrawprogram/Clipart” folder to the volume list.

Since: 2.4

## getAction

fileChooserGetAction Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m FileChooserAction | Returns: the action that the file selector is performing

Gets the type of operation that the file chooser is performing; see `fileChooserSetAction`.

Since: 2.4

## getChoice

fileChooserGetChoice Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `id`: the ID of the choice to get
-> m Text | Returns: the ID of the currenly selected option

Gets the currently selected option in the 'choice' with the given ID.

Since: 3.22

## getCreateFolders

fileChooserGetCreateFolders Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if the Create Folder button should be displayed.

Gets whether file choser will offer to create new folders. See `fileChooserSetCreateFolders`.

Since: 2.18

## getCurrentFolder

fileChooserGetCurrentFolder Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe [Char]) | Returns: the full path of the current folder, or `Nothing` if the current path cannot be represented as a local filename. Free with `free`. This function will also return `Nothing` if the file chooser was unable to load the last folder that was requested from it; for example, as would be for calling `fileChooserSetCurrentFolder` on a nonexistent folder.

Gets the current folder of `chooser` as a local filename. See `fileChooserSetCurrentFolder`.

Note that this is the folder that the file chooser is currently displaying (e.g. "/home/username/Documents"), which is not the same as the currently-selected folder if the chooser is in `FileChooserActionSelectFolder` mode (e.g. "/home/username/Documents/selected-folder/". To get the currently-selected folder in that mode, use `fileChooserGetUri` as the usual way to get the selection.

Since: 2.4

## getCurrentFolderFile

fileChooserGetCurrentFolderFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe File) | Returns: the `File` for the current folder.

Gets the current folder of `chooser` as `File`. See `fileChooserGetCurrentFolderUri`.

Since: 2.14

## getCurrentFolderUri

fileChooserGetCurrentFolderUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe Text) | Returns: the URI for the current folder. Free with `free`. This function will also return `Nothing` if the file chooser was unable to load the last folder that was requested from it; for example, as would be for calling `fileChooserSetCurrentFolderUri` on a nonexistent folder.

Gets the current folder of `chooser` as an URI. See `fileChooserSetCurrentFolderUri`.

Note that this is the folder that the file chooser is currently displaying (e.g. "file:///home/username/Documents"), which is not the same as the currently-selected folder if the chooser is in `FileChooserActionSelectFolder` mode (e.g. "file:///home/username/Documents/selected-folder/". To get the currently-selected folder in that mode, use `fileChooserGetUri` as the usual way to get the selection.

Since: 2.4

## getCurrentName

fileChooserGetCurrentName Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Text | Returns: The raw text from the file chooser’s “Name” entry. Free this with `free`. Note that this string is not a full pathname or URI; it is whatever the contents of the entry are. Note also that this string is in UTF-8 encoding, which is not necessarily the system’s encoding for filenames.

Gets the current name in the file selector, as entered by the user in the text entry for “Name”.

This is meant to be used in save dialogs, to get the currently typed filename when the file itself does not exist yet. For example, an application that adds a custom extra widget to the file chooser for “file format” may want to change the extension of the typed filename based on the chosen format, say, from “.jpg” to “.png”.

Since: 3.10

## getDoOverwriteConfirmation

fileChooserGetDoOverwriteConfirmation Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if the file chooser will present a confirmation dialog; `False` otherwise.

Queries whether a file chooser is set to confirm for overwriting when the user types a file name that already exists.

Since: 2.8

## getExtraWidget

fileChooserGetExtraWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe Widget) | Returns: the current extra widget, or `Nothing`

Gets the current extra widget; see `fileChooserSetExtraWidget`.

Since: 2.4

## getFile

fileChooserGetFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m File | Returns: a selected `File`. You own the returned file; use `objectUnref` to release it.

Gets the `File` for the currently selected file in the file selector. If multiple files are selected, one of the files will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

Since: 2.14

## getFilename

fileChooserGetFilename Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe [Char]) | Returns: The currently selected filename, or `Nothing` if no file is selected, or the selected file can't be represented with a local filename. Free with `free`.

Gets the filename for the currently selected file in the file selector. The filename is returned as an absolute path. If multiple files are selected, one of the filenames will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

Since: 2.4

## getFilenames

fileChooserGetFilenames Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [[Char]] | Returns: a `SList` containing the filenames of all selected files and subfolders in the current folder. Free the returned list with `g_slist_free()`, and the filenames with `free`.

Lists all the selected files and subfolders in the current folder of `chooser`. The returned names are full absolute paths. If files in the current folder cannot be represented as local filenames they will be ignored. (See `fileChooserGetUris`)

Since: 2.4

## getFiles

fileChooserGetFiles Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [File] | Returns: a `SList` containing a `File` for each selected file and subfolder in the current folder. Free the returned list with `g_slist_free()`, and the files with `objectUnref`.

Lists all the selected files and subfolders in the current folder of `chooser` as `File`. An internal function, see `fileChooserGetUris`.

Since: 2.14

## getFilter

fileChooserGetFilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe FileFilter) | Returns: the current filter, or `Nothing`

Gets the current filter; see `fileChooserSetFilter`.

Since: 2.4

## getLocalOnly

fileChooserGetLocalOnly Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if only local files can be selected.

Gets whether only local files can be selected in the file selector. See `fileChooserSetLocalOnly`

Since: 2.4

## getPreviewFile

fileChooserGetPreviewFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe File) | Returns: the `File` for the file to preview, or `Nothing` if no file is selected. Free with `objectUnref`.

Gets the `File` that should be previewed in a custom preview Internal function, see `fileChooserGetPreviewUri`.

Since: 2.14

## getPreviewFilename

fileChooserGetPreviewFilename Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe [Char]) | Returns: the filename to preview, or `Nothing` if no file is selected, or if the selected file cannot be represented as a local filename. Free with `free`

Gets the filename that should be previewed in a custom preview widget. See `fileChooserSetPreviewWidget`.

Since: 2.4

## getPreviewUri

fileChooserGetPreviewUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe Text) | Returns: the URI for the file to preview, or `Nothing` if no file is selected. Free with `free`.

Gets the URI that should be previewed in a custom preview widget. See `fileChooserSetPreviewWidget`.

Since: 2.4

## getPreviewWidget

fileChooserGetPreviewWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe Widget) | Returns: the current preview widget, or `Nothing`

Gets the current preview widget; see `fileChooserSetPreviewWidget`.

Since: 2.4

## getPreviewWidgetActive

fileChooserGetPreviewWidgetActive Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if the preview widget is active for the current filename.

Gets whether the preview widget set by `fileChooserSetPreviewWidget` should be shown for the current filename. See `fileChooserSetPreviewWidgetActive`.

Since: 2.4

## getSelectMultiple

fileChooserGetSelectMultiple Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if multiple files can be selected.

Gets whether multiple files can be selected in the file selector. See `fileChooserSetSelectMultiple`.

Since: 2.4

## getShowHidden

fileChooserGetShowHidden Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if hidden files and folders are displayed.

Gets whether hidden files and folders are displayed in the file selector. See `fileChooserSetShowHidden`.

Since: 2.6

## getUri

fileChooserGetUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m (Maybe Text) | Returns: The currently selected URI, or `Nothing` if no file is selected. If `fileChooserSetLocalOnly` is set to `True` (the default) a local URI will be returned for any FUSE locations. Free with `free`

Gets the URI for the currently selected file in the file selector. If multiple files are selected, one of the filenames will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

Since: 2.4

## getUris

fileChooserGetUris Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [Text] | Returns: a `SList` containing the URIs of all selected files and subfolders in the current folder. Free the returned list with `g_slist_free()`, and the filenames with `free`.

Lists all the selected files and subfolders in the current folder of `chooser`. The returned names are full absolute URIs.

Since: 2.4

## getUsePreviewLabel

fileChooserGetUsePreviewLabel Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m Bool | Returns: `True` if the file chooser is set to display a label with the name of the previewed file, `False` otherwise.

Gets whether a stock label should be drawn with the name of the previewed file. See `fileChooserSetUsePreviewLabel`.

## listFilters

fileChooserListFilters Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [FileFilter] | Returns: a `SList` containing the current set of user selectable filters. The contents of the list are owned by GTK+, but you must free the list itself with `g_slist_free()` when you are done with it.

Lists the current set of user-selectable filters; see `fileChooserAddFilter`, `fileChooserRemoveFilter`.

Since: 2.4

## listShortcutFolderUris

fileChooserListShortcutFolderUris Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [Text] | Returns: A list of folder URIs, or `Nothing` if there are no shortcut folders. Free the returned list with `g_slist_free()`, and the URIs with `free`.

Queries the list of shortcut folders in the file chooser, as set by `fileChooserAddShortcutFolderUri`.

Since: 2.4

## listShortcutFolders

fileChooserListShortcutFolders Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m [[Char]] | Returns: A list of folder filenames, or `Nothing` if there are no shortcut folders. Free the returned list with `g_slist_free()`, and the filenames with `free`.

Queries the list of shortcut folders in the file chooser, as set by `fileChooserAddShortcutFolder`.

Since: 2.4

## removeChoice

fileChooserRemoveChoice Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `id`: the ID of the choice to remove
-> m () |

Removes a 'choice' that has been added with `fileChooserAddChoice`.

Since: 3.22

## removeFilter

fileChooserRemoveFilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) |
=> a | `chooser`: a `FileChooser`
-> b | `filter`: a `FileFilter`
-> m () |

Removes `filter` from the list of filters that the user can select between.

Since: 2.4

## removeShortcutFolder

fileChooserRemoveShortcutFolder Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `folder`: filename of the folder to remove
-> m () | (Can throw `GError`)

Removes a folder from a file chooser’s list of shortcut folders.

Since: 2.4

## removeShortcutFolderUri

fileChooserRemoveShortcutFolderUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: URI of the folder to remove
-> m () | (Can throw `GError`)

Removes a folder URI from a file chooser’s list of shortcut folders.

Since: 2.4

## selectAll

fileChooserSelectAll Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m () |

Selects all the files in the current folder of a file chooser.

Since: 2.4

## selectFile

fileChooserSelectFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) |
=> a | `chooser`: a `FileChooser`
-> b | `file`: the file to select
-> m () | (Can throw `GError`)

Selects the file referred to by `file`. An internal function. See `_gtk_file_chooser_select_uri()`.

Since: 2.14

## selectFilename

fileChooserSelectFilename Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `filename`: the filename to select
-> m Bool | Returns: Not useful. See also: `fileChooserSetFilename`

Selects a filename. If the file name isn’t in the current folder of `chooser`, then the current folder of `chooser` will be changed to the folder containing `filename`.

Since: 2.4

## selectUri

fileChooserSelectUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: the URI to select
-> m Bool | Returns: Not useful.

Selects the file to by `uri`. If the URI doesn’t refer to a file in the current folder of `chooser`, then the current folder of `chooser` will be changed to the folder containing `filename`.

Since: 2.4

## setAction

fileChooserSetAction Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> FileChooserAction | `action`: the action that the file selector is performing
-> m () |

Sets the type of operation that the chooser is performing; the user interface is adapted to suit the selected action. For example, an option to create a new folder might be shown if the action is `FileChooserActionSave` but not if the action is `FileChooserActionOpen`.

Since: 2.4

## setChoice

fileChooserSetChoice Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `id`: the ID of the choice to set
-> Text | `option`: the ID of the option to select
-> m () |

Selects an option in a 'choice' that has been added with `fileChooserAddChoice`. For a boolean choice, the possible options are "true" and "false".

Since: 3.22

## setCreateFolders

fileChooserSetCreateFolders Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `createFolders`: `True` if the Create Folder button should be displayed
-> m () |

Sets whether file choser will offer to create new folders. This is only relevant if the action is not set to be `FileChooserActionOpen`.

Since: 2.18

## setCurrentFolder

fileChooserSetCurrentFolder Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `filename`: the full path of the new current folder
-> m Bool | Returns: Not useful.

Sets the current folder for `chooser` from a local filename. The user will be shown the full contents of the current folder, plus user interface elements for navigating to other folders.

In general, you should not use this function. See the [section on setting up a file chooser dialog][gtkfilechooserdialog-setting-up] for the rationale behind this.

Since: 2.4

## setCurrentFolderFile

fileChooserSetCurrentFolderFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) |
=> a | `chooser`: a `FileChooser`
-> b | `file`: the `File` for the new folder
-> m () | (Can throw `GError`)

Sets the current folder for `chooser` from a `File`. Internal function, see `fileChooserSetCurrentFolderUri`.

Since: 2.14

## setCurrentFolderUri

fileChooserSetCurrentFolderUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: the URI for the new current folder
-> m Bool | Returns: `True` if the folder could be changed successfully, `False` otherwise.

Sets the current folder for `chooser` from an URI. The user will be shown the full contents of the current folder, plus user interface elements for navigating to other folders.

In general, you should not use this function. See the [section on setting up a file chooser dialog][gtkfilechooserdialog-setting-up] for the rationale behind this.

Since: 2.4

## setCurrentName

fileChooserSetCurrentName Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `name`: the filename to use, as a UTF-8 string
-> m () |

Sets the current name in the file selector, as if entered by the user. Note that the name passed in here is a UTF-8 string rather than a filename. This function is meant for such uses as a suggested name in a “Save As...” dialog. You can pass “Untitled.doc” or a similarly suitable suggestion for the `name`.

If you want to preselect a particular existing file, you should use `fileChooserSetFilename` or `fileChooserSetUri` instead. Please see the documentation for those functions for an example of using `fileChooserSetCurrentName` as well.

Since: 2.4

## setDoOverwriteConfirmation

fileChooserSetDoOverwriteConfirmation Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `doOverwriteConfirmation`: whether to confirm overwriting in save mode
-> m () |

Sets whether a file chooser in `FileChooserActionSave` mode will present a confirmation dialog if the user types a file name that already exists. This is `False` by default.

If set to `True`, the `chooser` will emit the FileChooser::confirmOverwrite signal when appropriate.

If all you need is the stock confirmation dialog, set this property to `True`. You can override the way confirmation is done by actually handling the FileChooser::confirmOverwrite signal; please refer to its documentation for the details.

Since: 2.8

## setExtraWidget

fileChooserSetExtraWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsWidget b) |
=> a | `chooser`: a `FileChooser`
-> b | `extraWidget`: widget for extra options
-> m () |

Sets an application-supplied widget to provide extra options to the user.

Since: 2.4

## setFile

fileChooserSetFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) |
=> a | `chooser`: a `FileChooser`
-> b | `file`: the `File` to set as current
-> m () | (Can throw `GError`)

Sets `file` as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list. If the `chooser` is in `FileChooserActionSave` mode, the file’s base name will also appear in the dialog’s file name entry.

If the file name isn’t in the current folder of `chooser`, then the current folder of `chooser` will be changed to the folder containing `filename`. This is equivalent to a sequence of `fileChooserUnselectAll` followed by `fileChooserSelectFilename`.

Note that the file must exist, or nothing will be done except for the directory change.

If you are implementing a save dialog, you should use this function if you already have a file name to which the user may save; for example, when the user opens an existing file and then does Save As... If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

### C code

    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_folder_file (chooser, default_file_for_saving);
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_file (chooser, existing_file);
      }

Since: 2.14

## setFilename

fileChooserSetFilename Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `filename`: the filename to set as current
-> m Bool | Returns: Not useful.

Sets `filename` as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list; all other files will be unselected. If the `chooser` is in `FileChooserActionSave` mode, the file’s base name will also appear in the dialog’s file name entry.

Note that the file must exist, or nothing will be done except for the directory change.

You should use this function only when implementing a save dialog for which you already have a file name to which the user may save. For example, when the user opens an existing file and then does Save As... to save a copy or a modified version. If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

### C code

    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_filename (chooser, existing_filename);
      }

In the first case, the file chooser will present the user with useful suggestions as to where to save his new file. In the second case, the file’s existing location is already known, so the file chooser will use it.

Since: 2.4

## setFilter

fileChooserSetFilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFileFilter b) |
=> a | `chooser`: a `FileChooser`
-> b | `filter`: a `FileFilter`
-> m () |

Sets the current filter; only the files that pass the filter will be displayed. If the user-selectable list of filters is non-empty, then the filter should be one of the filters in that list. Setting the current filter when the list of filters is empty is useful if you want to restrict the displayed set of files without letting the user change it.

Since: 2.4

## setLocalOnly

fileChooserSetLocalOnly Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `localOnly`: `True` if only local files can be selected
-> m () |

Sets whether only local files can be selected in the file selector. If `localOnly` is `True` (the default), then the selected file or files are guaranteed to be accessible through the operating systems native file system and therefore the application only needs to worry about the filename functions in `FileChooser`, like `fileChooserGetFilename`, rather than the URI functions like `fileChooserGetUri`,

On some systems non-native files may still be available using the native filesystem via a userspace filesystem (FUSE).

Since: 2.4

## setPreviewWidget

fileChooserSetPreviewWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsWidget b) |
=> a | `chooser`: a `FileChooser`
-> b | `previewWidget`: widget for displaying preview.
-> m () |

Sets an application-supplied widget to use to display a custom preview of the currently selected file. To implement a preview, after setting the preview widget, you connect to the FileChooser::updatePreview signal, and call `fileChooserGetPreviewFilename` or `fileChooserGetPreviewUri` on each change. If you can display a preview of the new file, update your widget and set the preview active using `fileChooserSetPreviewWidgetActive`. Otherwise, set the preview inactive.

When there is no application-supplied preview widget, or the application-supplied preview widget is not active, the file chooser will display no preview at all.

Since: 2.4

## setPreviewWidgetActive

fileChooserSetPreviewWidgetActive Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `active`: whether to display the user-specified preview widget
-> m () |

Sets whether the preview widget set by `fileChooserSetPreviewWidget` should be shown for the current filename. When `active` is set to false, the file chooser may display an internally generated preview of the current file or it may display no preview at all. See `fileChooserSetPreviewWidget` for more details.

Since: 2.4

## setSelectMultiple

fileChooserSetSelectMultiple Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `selectMultiple`: `True` if multiple files can be selected.
-> m () |

Sets whether multiple files can be selected in the file selector. This is only relevant if the action is set to be `FileChooserActionOpen` or `FileChooserActionSelectFolder`.

Since: 2.4

## setShowHidden

fileChooserSetShowHidden Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `showHidden`: `True` if hidden files and folders should be displayed.
-> m () |

Sets whether hidden files and folders are displayed in the file selector.

Since: 2.6

## setUri

fileChooserSetUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: the URI to set as current
-> m Bool | Returns: Not useful.

Sets the file referred to by `uri` as the current file for the file chooser, by changing to the URI’s parent folder and actually selecting the URI in the list. If the `chooser` is `FileChooserActionSave` mode, the URI’s base name will also appear in the dialog’s file name entry.

Note that the URI must exist, or nothing will be done except for the directory change.

You should use this function only when implementing a save dialog for which you already have a file name to which the user may save. For example, when the user opens an existing file and then does Save As... to save a copy or a modified version. If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

### C code

    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_uri (chooser, existing_uri);
      }

In the first case, the file chooser will present the user with useful suggestions as to where to save his new file. In the second case, the file’s existing location is already known, so the file chooser will use it.

Since: 2.4

## setUsePreviewLabel

fileChooserSetUsePreviewLabel Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Bool | `useLabel`: whether to display a stock label with the name of the previewed file
-> m () |

Sets whether the file chooser should display a stock label with the name of the file that is being previewed; the default is `True`. Applications that want to draw the whole preview area themselves should set this to `False` and display the name themselves in their preview widget.

See also: `fileChooserSetPreviewWidget`

Since: 2.4

## unselectAll

fileChooserUnselectAll Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> m () |

Unselects all the files in the current folder of a file chooser.

Since: 2.4

## unselectFile

fileChooserUnselectFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a, IsFile b) |
=> a | `chooser`: a `FileChooser`
-> b | `file`: a `File`
-> m () |

Unselects the file referred to by `file`. If the file is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

Since: 2.14

## unselectFilename

fileChooserUnselectFilename Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> [Char] | `filename`: the filename to unselect
-> m () |

Unselects a currently selected filename. If the filename is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

Since: 2.4

## unselectUri

fileChooserUnselectUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileChooser a) |
=> a | `chooser`: a `FileChooser`
-> Text | `uri`: the URI to unselect
-> m () |

Unselects the file referred to by `uri`. If the file is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

Since: 2.4

# Properties

## action

No description available in the introspection data.

constructFileChooserAction :: (IsFileChooser o, MonadIO m) => FileChooserAction -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`action`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserAction :: (MonadIO m, IsFileChooser o) => o -> m FileChooserAction Source #

Get the value of the “`action`” property. When overloading is enabled, this is equivalent to

    get fileChooser #action

setFileChooserAction :: (MonadIO m, IsFileChooser o) => o -> FileChooserAction -> m () Source #

Set the value of the “`action`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #action := value ]

## createFolders

Whether a file chooser not in `FileChooserActionOpen` mode will offer the user to create new folders.

Since: 2.18

constructFileChooserCreateFolders :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`create-folders`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserCreateFolders :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`create-folders`” property. When overloading is enabled, this is equivalent to

    get fileChooser #createFolders

setFileChooserCreateFolders :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`create-folders`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #createFolders := value ]

## doOverwriteConfirmation

Whether a file chooser in `FileChooserActionSave` mode will present an overwrite confirmation dialog if the user selects a file name that already exists.

Since: 2.8

constructFileChooserDoOverwriteConfirmation :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`do-overwrite-confirmation`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserDoOverwriteConfirmation :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`do-overwrite-confirmation`” property. When overloading is enabled, this is equivalent to

    get fileChooser #doOverwriteConfirmation

setFileChooserDoOverwriteConfirmation :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`do-overwrite-confirmation`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #doOverwriteConfirmation := value ]

## extraWidget

No description available in the introspection data.

constructFileChooserExtraWidget :: (IsFileChooser o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`extra-widget`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserExtraWidget :: (MonadIO m, IsFileChooser o) => o -> m (Maybe Widget) Source #

Get the value of the “`extra-widget`” property. When overloading is enabled, this is equivalent to

    get fileChooser #extraWidget

setFileChooserExtraWidget :: (MonadIO m, IsFileChooser o, IsWidget a) => o -> a -> m () Source #

Set the value of the “`extra-widget`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #extraWidget := value ]

## filter

No description available in the introspection data.

constructFileChooserFilter :: (IsFileChooser o, MonadIO m, IsFileFilter a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`filter`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserFilter :: (MonadIO m, IsFileChooser o) => o -> m (Maybe FileFilter) Source #

Get the value of the “`filter`” property. When overloading is enabled, this is equivalent to

    get fileChooser #filter

setFileChooserFilter :: (MonadIO m, IsFileChooser o, IsFileFilter a) => o -> a -> m () Source #

Set the value of the “`filter`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #filter := value ]

## localOnly

No description available in the introspection data.

constructFileChooserLocalOnly :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`local-only`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserLocalOnly :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`local-only`” property. When overloading is enabled, this is equivalent to

    get fileChooser #localOnly

setFileChooserLocalOnly :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`local-only`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #localOnly := value ]

## previewWidget

No description available in the introspection data.

constructFileChooserPreviewWidget :: (IsFileChooser o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`preview-widget`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserPreviewWidget :: (MonadIO m, IsFileChooser o) => o -> m (Maybe Widget) Source #

Get the value of the “`preview-widget`” property. When overloading is enabled, this is equivalent to

    get fileChooser #previewWidget

setFileChooserPreviewWidget :: (MonadIO m, IsFileChooser o, IsWidget a) => o -> a -> m () Source #

Set the value of the “`preview-widget`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #previewWidget := value ]

## previewWidgetActive

No description available in the introspection data.

constructFileChooserPreviewWidgetActive :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`preview-widget-active`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserPreviewWidgetActive :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`preview-widget-active`” property. When overloading is enabled, this is equivalent to

    get fileChooser #previewWidgetActive

setFileChooserPreviewWidgetActive :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`preview-widget-active`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #previewWidgetActive := value ]

## selectMultiple

No description available in the introspection data.

constructFileChooserSelectMultiple :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`select-multiple`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserSelectMultiple :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`select-multiple`” property. When overloading is enabled, this is equivalent to

    get fileChooser #selectMultiple

setFileChooserSelectMultiple :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`select-multiple`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #selectMultiple := value ]

## showHidden

No description available in the introspection data.

constructFileChooserShowHidden :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`show-hidden`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserShowHidden :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`show-hidden`” property. When overloading is enabled, this is equivalent to

    get fileChooser #showHidden

setFileChooserShowHidden :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`show-hidden`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #showHidden := value ]

## usePreviewLabel

No description available in the introspection data.

constructFileChooserUsePreviewLabel :: (IsFileChooser o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`use-preview-label`” property. This is rarely needed directly, but it is used by `new`.

getFileChooserUsePreviewLabel :: (MonadIO m, IsFileChooser o) => o -> m Bool Source #

Get the value of the “`use-preview-label`” property. When overloading is enabled, this is equivalent to

    get fileChooser #usePreviewLabel

setFileChooserUsePreviewLabel :: (MonadIO m, IsFileChooser o) => o -> Bool -> m () Source #

Set the value of the “`use-preview-label`” property. When overloading is enabled, this is equivalent to

    set fileChooser [ #usePreviewLabel := value ]

# Signals

## confirmOverwrite

type FileChooserConfirmOverwriteCallback Source #

Arguments

= IO FileChooserConfirmation | Returns: a `FileChooserConfirmation` value that indicates which action to take after emitting the signal.

This signal gets emitted whenever it is appropriate to present a confirmation dialog when the user has selected a file name that already exists. The signal only gets emitted when the file chooser is in `FileChooserActionSave` mode.

Most applications just need to turn on the FileChooser:doOverwriteConfirmation property (or call the `fileChooserSetDoOverwriteConfirmation` function), and they will automatically get a stock confirmation dialog. Applications which need to customize this behavior should do that, and also connect to the FileChooser::confirmOverwrite signal.

A signal handler for this signal must return a `FileChooserConfirmation` value, which indicates the action to take. If the handler determines that the user wants to select a different filename, it should return `FileChooserConfirmationSelectAgain`. If it determines that the user is satisfied with his choice of file name, it should return `FileChooserConfirmationAcceptFilename`. On the other hand, if it determines that the stock confirmation dialog should be used, it should return `FileChooserConfirmationConfirm`. The following example illustrates this.

## Custom confirmation ## {`gtkfilechooser`-confirmation}

### C code

    static GtkFileChooserConfirmation
    confirm_overwrite_callback (GtkFileChooser *chooser, gpointer data)
    {
      char *uri;

      uri = gtk_file_chooser_get_uri (chooser);

      if (is_uri_read_only (uri))
        {
          if (user_wants_to_replace_read_only_file (uri))
            return GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME;
          else
            return GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN;
        } else
          return GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM; // fall back to the default dialog
    }

    ...

    chooser = gtk_file_chooser_dialog_new (...);

    gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog), TRUE);
    g_signal_connect (chooser, "confirm-overwrite",
                      G_CALLBACK (confirm_overwrite_callback), NULL);

    if (gtk_dialog_run (chooser) == GTK_RESPONSE_ACCEPT)
            save_to_file (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (chooser));

    gtk_widget_destroy (chooser);

Since: 2.8

afterFileChooserConfirmOverwrite :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserConfirmOverwriteCallback) -> m SignalHandlerId Source #

Connect a signal handler for the confirmOverwrite signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after fileChooser #confirmOverwrite callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onFileChooserConfirmOverwrite :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserConfirmOverwriteCallback) -> m SignalHandlerId Source #

Connect a signal handler for the confirmOverwrite signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on fileChooser #confirmOverwrite callback

## currentFolderChanged

type FileChooserCurrentFolderChangedCallback = IO () Source #

This signal is emitted when the current folder in a `FileChooser` changes. This can happen due to the user performing some action that changes folders, such as selecting a bookmark or visiting a folder on the file list. It can also happen as a result of calling a function to explicitly change the current folder in a file chooser.

Normally you do not need to connect to this signal, unless you need to keep track of which folder a file chooser is showing.

See also: `fileChooserSetCurrentFolder`, `fileChooserGetCurrentFolder`, `fileChooserSetCurrentFolderUri`, `fileChooserGetCurrentFolderUri`.

afterFileChooserCurrentFolderChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserCurrentFolderChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the currentFolderChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after fileChooser #currentFolderChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onFileChooserCurrentFolderChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserCurrentFolderChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the currentFolderChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on fileChooser #currentFolderChanged callback

## fileActivated

type FileChooserFileActivatedCallback = IO () Source #

This signal is emitted when the user "activates" a file in the file chooser. This can happen by double-clicking on a file in the file list, or by pressing `Enter`.

Normally you do not need to connect to this signal. It is used internally by `FileChooserDialog` to know when to activate the default button in the dialog.

See also: `fileChooserGetFilename`, `fileChooserGetFilenames`, `fileChooserGetUri`, `fileChooserGetUris`.

afterFileChooserFileActivated :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserFileActivatedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the fileActivated signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after fileChooser #fileActivated callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onFileChooserFileActivated :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserFileActivatedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the fileActivated signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on fileChooser #fileActivated callback

## selectionChanged

type FileChooserSelectionChangedCallback = IO () Source #

This signal is emitted when there is a change in the set of selected files in a `FileChooser`. This can happen when the user modifies the selection with the mouse or the keyboard, or when explicitly calling functions to change the selection.

Normally you do not need to connect to this signal, as it is easier to wait for the file chooser to finish running, and then to get the list of selected files using the functions mentioned below.

See also: `fileChooserSelectFilename`, `fileChooserUnselectFilename`, `fileChooserGetFilename`, `fileChooserGetFilenames`, `fileChooserSelectUri`, `fileChooserUnselectUri`, `fileChooserGetUri`, `fileChooserGetUris`.

afterFileChooserSelectionChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserSelectionChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectionChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after fileChooser #selectionChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onFileChooserSelectionChanged :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserSelectionChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectionChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on fileChooser #selectionChanged callback

## updatePreview

type FileChooserUpdatePreviewCallback = IO () Source #

This signal is emitted when the preview in a file chooser should be regenerated. For example, this can happen when the currently selected file changes. You should use this signal if you want your file chooser to have a preview widget.

Once you have installed a preview widget with `fileChooserSetPreviewWidget`, you should update it when this signal is emitted. You can use the functions `fileChooserGetPreviewFilename` or `fileChooserGetPreviewUri` to get the name of the file to preview. Your widget may not be able to preview all kinds of files; your callback must call `fileChooserSetPreviewWidgetActive` to inform the file chooser about whether the preview was generated successfully or not.

Please see the example code in [Using a Preview Widget][gtkfilechooser-preview].

See also: `fileChooserSetPreviewWidget`, `fileChooserSetPreviewWidgetActive`, `fileChooserSetUsePreviewLabel`, `fileChooserGetPreviewFilename`, `fileChooserGetPreviewUri`.

afterFileChooserUpdatePreview :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserUpdatePreviewCallback) -> m SignalHandlerId Source #

Connect a signal handler for the updatePreview signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after fileChooser #updatePreview callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onFileChooserUpdatePreview :: (IsFileChooser a, MonadIO m) => a -> ((?self :: a) => FileChooserUpdatePreviewCallback) -> m SignalHandlerId Source #

Connect a signal handler for the updatePreview signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on fileChooser #updatePreview callback